#include "tsbrowse3.h"
#pragma hdrstop

#include "tsb3_f_pnot.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TProjectNotifierForm *ProjectNotifierForm;
//---------------------------------------------------------------------------

typedef void __fastcall (__closure *TProjectEventEvent)(TObject *Sender,TEventNotification NotifyCode, bool &Cancel);
typedef void __fastcall (__closure *TProjectFileEvent)(TObject *Sender,TFileNotification NotifyCode, const AnsiString FileName, bool &Cancel);

class TProjectNotifier : public TIAddInNotifier
{
public:
  __fastcall TProjectNotifier() {OnEvent=NULL; OnFile=NULL;}
  void __stdcall EventNotification(TEventNotification Event, bool &Cancel)
  { if (OnEvent!=NULL) OnEvent(this,Event,Cancel);
  }
  void __stdcall FileNotification(TFileNotification NotifyCode,const AnsiString FileName, bool &Cancel)
  { if (OnFile!=NULL) OnFile(this,NotifyCode,FileName,Cancel);
  }
  TProjectEventEvent OnEvent;
  TProjectFileEvent OnFile;
};

__fastcall TProjectNotifierForm::TProjectNotifierForm(TComponent* Owner)
        : TForm(Owner)
{ TProjectNotifier *pn=new TProjectNotifier();
  pn->OnEvent=ProjectNotifyEvent;
  pn->OnFile=ProjectNotifyFile;
  ToolServices->AddNotifier(pn);
  ain=pn;
}
__fastcall TProjectNotifierForm::~TProjectNotifierForm()
{ Halt();
}
void __fastcall TProjectNotifierForm::Halt()
{ if (ain==NULL) return;
  ToolServices->RemoveNotifier(ain);
  delete ain; ain=NULL;
}
void __fastcall TProjectNotifierForm::ProjectNotifyEvent(TObject *Sender,TEventNotification NotifyCode, bool &Cancel)
{ AnsiString s="unknown event code";
  switch (NotifyCode)
  { case enBeforeCompile: s="enBeforeCompile"; break;
    case enAfterCompile: s="enAfterCompile: "; if (Cancel) s=s+"success"; else s=s+"failure"; break;
  }
  Log->Lines->Add(s);
}
void __fastcall TProjectNotifierForm::ProjectNotifyFile(TObject *Sender,TFileNotification NotifyCode, const AnsiString FileName, bool &Cancel)
{ AnsiString s="unknown code";
  bool ap=true;
  switch (NotifyCode)
  { case fnFileOpening: s="fnFileOpening"; break;
    case fnFileOpened: s="fnFileOpened"; break;
    case fnFileClosing: s="fnFileClosing"; break;
    case fnProjectOpening: s="fnProjectOpening"; break;
    case fnProjectOpened: s="fnProjectOpened"; break;
    case fnProjectClosing: s="fnProjectClosing"; break;
    case fnAddedToProject: s="fnAddedToProject"; break;
    case fnRemovedFromProject: s="fnRemovedFromProject"; break;
    case fnDefaultDesktopLoad: s="fnDefaultDesktopLoad"; break;
    case fnDefaultDesktopSave: s="fnDefaultDesktopSave"; break;
    case fnProjectDesktopLoad: s="fnProjectDesktopLoad"; break;
    case fnprojectDesktopSave: s="fnprojectDesktopSave"; break; // LOWER CASE!!!
    case fnPackageInstalled: s="fnPackageInstalled"; break;
    case fnPackageUninstalled: s="fnPackageUninstalled"; break;
  }
  if (ap) s=s+" - "+FileName;
  Log->Lines->Add(s);
}

//---------------------------------------------------------------------------
void __fastcall TProjectNotifierForm::FormClose(TObject *Sender,TCloseAction &Action)
{ Halt();
  Action=caFree;
}
//---------------------------------------------------------------------------
void __fastcall TProjectNotifierForm::btnRemoveNotifierClick(TObject *Sender)
{ Close();
}
//---------------------------------------------------------------------------
void __fastcall TProjectNotifierForm::btnClearLogClick(TObject *Sender)
{ Log->Clear();
}
//---------------------------------------------------------------------------
