#include "tsbrowse3.h"
#pragma hdrstop

#include "tsb3_f_rentry.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TResourceEntryForm *ResourceEntryForm;
//---------------------------------------------------------------------------

char *buf=NULL;
char* __fastcall ResourceTypeFromString(AnsiString s)
{ if (s=="RT_RCDATA") return RT_RCDATA;
  if (s=="RT_DIALOG") return RT_DIALOG;
  if (s=="RT_FONT") return RT_FONT;
  if (s=="RT_FONTDIR") return RT_FONTDIR;
  if (s=="RT_MENU") return RT_MENU;
  if (s=="RT_STRING") return RT_STRING;
  if (s=="RT_MESSAGETABLE") return RT_MESSAGETABLE;
  if (s=="RT_CURSOR") return RT_CURSOR;
  if (s=="RT_GROUP_CURSOR") return RT_GROUP_CURSOR;
  if (s=="RT_BITMAP") return RT_BITMAP;
  if (s=="RT_ICON") return RT_ICON;
  if (s=="RT_GROUP_ICON") return RT_GROUP_ICON;
  if (s=="RT_VERSION") return RT_VERSION;
  if (s.SubString(1,1)=='\"' && s.SubString(s.Length(),1)=='\"')
  { AnsiString t=s.SubString(2,s.Length()-2);
    if (buf!=NULL) delete buf;
    buf=new char[t.Length()+1];
    strcpy(buf,t.c_str());
    return buf;
  }
  int i; try {i=s.ToInt();} catch (EConvertError &err) {return NULL;}
  return MAKEINTRESOURCE(i);
}
AnsiString __fastcall ResourceTypeToString(char *type)
{ if (type==RT_RCDATA) return "RT_RCDATA";
  if (type==RT_DIALOG) return "RT_DIALOG";
  if (type==RT_FONT) return "RT_FONT";
  if (type==RT_FONTDIR) return "RT_FONTDIR";
  if (type==RT_MENU) return "RT_MENU";
  if (type==RT_STRING) return "RT_STRING";
  if (type==RT_MESSAGETABLE) return "RT_MESSAGETABLE";
  if (type==RT_CURSOR) return "RT_CURSOR";
  if (type==RT_GROUP_CURSOR) return "RT_GROUP_CURSOR";
  if (type==RT_ICON) return "RT_ICON";
  if (type==RT_GROUP_ICON) return "RT_GROUP_ICON";
  if (type==RT_VERSION) return "RT_VERSION";
  if (type==RT_BITMAP) return "RT_BITMAP";
  DWORD d=(DWORD)type;
  if (HIWORD(d)==0) return AnsiString((int)d);
  // So it's just plain text. We'll do a little rigmarole to ensure that
  // we won't possible give an access violation trying to read it.
  char dst[MAX_PATH]; char *src=type; bool done=false; int lastchar;
  for (int i=0; i<MAX_PATH-1 && !done; i++) {dst[i]=src[i]; lastchar=i; if (src[i]==0 || IsBadReadPtr(src+i,1)) done=true;}
  dst[lastchar+1]=0; return "\""+AnsiString(dst)+"\"";
}

char *nbuf=NULL;
char* __fastcall ResourceNameFromString(AnsiString s)
{ if (s.SubString(1,1)=='\"' && s.SubString(s.Length(),1)=='\"')
  { AnsiString t=s.SubString(2,s.Length()-2);
    if (nbuf!=NULL) delete nbuf;
    nbuf=new char[t.Length()+1];
    strcpy(nbuf,t.c_str());
    return nbuf;
  }
  try
  { int i=s.ToInt(); return MAKEINTRESOURCE(i);
  }
  catch (EConvertError &err)
  { Application->MessageBox("Bad name. If you want a string name, enclose it in quotes.","Bad resource name",MB_OK);
    return NULL;
  }
}
AnsiString __fastcall ResourceNameToString(char *name)
{ DWORD d=(DWORD)name;
  if (HIWORD(d)==0) return AnsiString((int)d);
  char dst[MAX_PATH]; char *src=name; bool done=false; int lastchar;
  for (int i=0; i<MAX_PATH-1 && !done; i++) {dst[i]=src[i]; lastchar=i; if (src[i]==0 || IsBadReadPtr(src+i,1)) done=true;}
  dst[lastchar+1]=0; return "\""+AnsiString(dst)+"\"";
}







//---------------------------------------------------------------------------
//---------------------------------------------------------------------------


__fastcall TResourceEntryForm::TResourceEntryForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TResourceEntryForm::btnGetResourceTypeClick(
      TObject *Sender)
{ char *type=re->GetResourceType();
  tGetResourceType->Caption=ResourceTypeToString(type);
}
//---------------------------------------------------------------------------
void __fastcall TResourceEntryForm::btnGetResourceNameClick(
      TObject *Sender)
{ tGetResourceName->Caption=ResourceNameToString(re->GetResourceName());
}
//---------------------------------------------------------------------------
void __fastcall TResourceEntryForm::btnChangeClick(TObject *Sender)
{ char *name=ResourceNameFromString(eChange->Text);
  char *type=ResourceTypeFromString(cbChange->Text);
  if (type==NULL || name==NULL) {MessageBeep(0);return;}
  re->Change(type,name);
  DataMemo->Visible=false;
  DataImage->Visible=false;
}
//---------------------------------------------------------------------------
void __fastcall TResourceEntryForm::btnGetEntryHandleClick(TObject *Sender)
{ void*h=re->GetEntryHandle();
  tGetEntryHandle->Caption="0x"+IntToHex((int)h,8);
}
//---------------------------------------------------------------------------
void __fastcall TResourceEntryForm::btnGetHeaderValueClick(TObject *Sender)
{ TResHeaderValue hv;
  int i=cbHeaderValue->ItemIndex;
  if (i==0) hv=hvFlags;
  else if (i==1) hv=hvLanguage;
  else if (i==2) hv=hvDataVersion;
  else if (i==3) hv=hvVersion;
  else if (i==4) hv=hvCharacteristics;
  else {MessageBeep(0);return;}
  int val;
  bool res=re->GetHeaderValue(hv,val);
  if (!res) {Application->MessageBox("Error getting header value","Error",MB_OK);return;}
  tGetHeaderValue->Caption="0x"+IntToHex(val,8);
}
//---------------------------------------------------------------------------
void __fastcall TResourceEntryForm::btnSetHeaderValueClick(TObject *Sender)
{ TResHeaderValue hv;
  int i=cbHeaderValue->ItemIndex;
  if (i==0) hv=hvFlags;
  else if (i==1) hv=hvLanguage;
  else if (i==2) hv=hvDataVersion;
  else if (i==3) hv=hvVersion;
  else if (i==4) hv=hvCharacteristics;
  else {MessageBeep(0);return;}
  int val;
  try {val=eSetHeaderValue->Text.ToInt();} catch (EConvertError &err) {MessageBeep(0);return;}
  bool res=re->SetHeaderValue(hv,val);
  if (!res) {Application->MessageBox("Error setting header value","Error",MB_OK);return;}
}
//---------------------------------------------------------------------------


void __fastcall TResourceEntryForm::btnGetDataClick(TObject *Sender)
{ TResourceDataStream *ds=new TResourceDataStream(re); int size=re->GetDataSize();
  char *type=re->GetResourceType();
  tGetData->Caption=ResourceTypeToString(type)+": "+AnsiString(size);
  if (type==RT_BITMAP && size>sizeof(TBitmapCoreHeader))
  { // Bitmaps need a header added before TBitmap can stream them in
    // We'll construct this new thing in a TMemoryStream
    TMemoryStream *ms=new TMemoryStream();
    TBitmapFileHeader bfh; bfh.bfType=0x4D42;
    char *src=(char*)re->GetData();
    TBitmapInfoHeader *bih=(TBitmapInfoHeader*)src;
    if (bih->biSize==sizeof(TBitmapCoreHeader))
    { int ncolors = 1 << (bih->biPlanes*bih->biBitCount);
      bfh.bfOffBits=bih->biSize+ncolors*sizeof(RGBQUAD);
      // Lischner: pad to a long word boundary
      bfh.bfSize = sizeof(bfh) + bfh.bfOffBits + ((bih->biWidth+3)/2)*2 * bih->biHeight;
    }
    else
    { int ncolors;
      if (bih->biClrUsed!=0 || bih->biBitCount>=16) ncolors=bih->biClrUsed;
      else ncolors = 1 << (bih->biPlanes*bih->biBitCount);
      bfh.bfOffBits = bih->biSize+ncolors*sizeof(RGBQUAD);
      // Lischner: If the image is compressed, biSizeImage contains the number
      // of bytes in the compressed image. For uncompressed images, biSizeImage is usually 0,
      // so compute the size. Scan lines are padded to long word boundaries.
      int h=bih->biHeight; if (h<0) h=-h;
      if (bih->biSizeImage==0) bfh.bfSize=sizeof(bfh) + bfh.bfOffBits + ((bih->biWidth+3)/2)*2 * h;
      else bfh.bfSize = sizeof(bfh) + bfh.bfOffBits + bih->biSizeImage;
    }
    ms->WriteBuffer(&bfh,sizeof(bfh)); ms->WriteBuffer(src,size);
    ms->Position=0;
    DataImage->Stretch=true;
    DataImage->Picture->Bitmap->LoadFromStream(ms);
    delete ms;
    DataImage->Visible=true;
    DataMemo->Visible=false;
  }
  else if (type==RT_ICON || type==RT_CURSOR || type==RT_ANICURSOR)
  { DataImage->Stretch=false;
    DataImage->Picture->Icon->Handle=CreateIconFromResource((LPBYTE)re->GetData(),size,type==RT_ICON,0x30000);
    DataImage->Visible=true;
    DataMemo->Visible=false;
  }
  else
  { char *c=new char[size];
    ds->ReadBuffer(c,size);
    char *dst=new char[size*2];
    int di=0;
    for (int i=0; i<size; i++)
    { unsigned char byte=c[i];
      if (byte<32 || byte>127) byte='.';
      dst[di]=byte; di++;
      if ((di%48)==0)
      { dst[di]='\r';di++;dst[di]='\n';di++;
      }
    }
    dst[di]=0;
    DataMemo->Lines->Text=AnsiString(dst);
    delete[] dst;
    delete[] c;
    DataImage->Visible=false;
    DataMemo->Visible=true;
  }
  delete ds;
}
//---------------------------------------------------------------------------
void __fastcall TResourceEntryForm::btnSetDataClick(TObject *Sender)
{ bool res=SetDataDialog->Execute();
  if (!res) return;
  AnsiString fn=SetDataDialog->FileName;
  TFileStream *fs=new TFileStream(fn,fmOpenRead|fmShareDenyWrite);
  re->SetDataSize(fs->Size);
  TResourceDataStream *ds=new TResourceDataStream(re);
  ds->CopyFrom(fs,fs->Size);
  delete ds;
  delete fs;
}
//---------------------------------------------------------------------------

